HDU-3466 Proud Merchants (和放入顺序有关的背包问题 经典题)

Proud Merchants

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 7117    Accepted Submission(s): 2963


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
  
  
2 10 10 15 10 5 10 5 3 10 5 10 5 3 5 6 2 7 3
 

Sample Output
  
  
5 11
 

#include <bits/stdc++.h>
using namespace std;
int dp[5001];
struct point{
	int p, q, v;
	bool operator < (const point& x){
		return q - p < x.q - x.p;
	}
}a[5001];
int main(){
	int n, m;
	while(scanf("%d %d", &n, &m) != EOF){
		memset(dp, 0, sizeof(dp));
		for(int i = 1; i <= n; ++i){
			scanf("%d %d %d", &a[i].p, &a[i].q, &a[i].v);
		}
		sort(a + 1, a + 1 + n);
		for(int i = 1; i <= n; ++i){
			for(int j = m; j >= a[i].q; --j){
				dp[j] = max(dp[j], dp[j - a[i].p] + a[i].v);
			}
		}
		printf("%d\n", dp[m]);
	}
}

/*
题意:n个物品,m元,每个物品有价格,价值,和购买时手上最少有多少钱。问m元最多买多少价值的物品。

思路:这题需要注意dp时遍历所有物品的顺序。我们考虑任意一个购买顺序,对于其中任意相邻的两个物品i,j,
这两个物品的购买顺序对于后面购买的物品没有影响,因为无论前面剩下多少钱,这两个是怎样的购买顺序,最后
只是消耗了pi + pj,但是会影响前面购买物品后需要剩下多少钱,假设i在j前面购买需要更少的钱,那么i在前面
购买需要pi + qj,j在i前面购买需要pj + qi,pi + qj < pj + qi => qi - pi > qj - pj,差值大的在前面购买需要
前面购买后剩下较少的钱,那么对于任意相邻我们都可以做这个调换。即我们先购买q-p差值大的。
那么在做背包时,转移方程是dp[j] = max(dp[j], dp[j - a[i].p] + a[i].v),实际上对于局部j,我们考虑的是最后
一次购买的是a[i],然后用dp[j - a[i].p]这个量去转移,所以我们需要先用最后购买的物品去先转移dp方程。
那么就是按q-p差值从小到大更新dp。
*/


  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值